#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ChannelCFG.h"
std::auto_ptr<M_ChannelCFG> M_ChannelCFG::msSingleton(nullptr);

int M_ChannelCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ChannelCFGData* M_ChannelCFG::GetData(std::string ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<std::string, M_ChannelCFGData>& M_ChannelCFG::GetMapData()
{
	return mMapData;
}

void M_ChannelCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ChannelCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ChannelCFGData data;
		data.mID = element->Attribute("ID");
		data.mIsPayWeb = element->IntAttribute("IsPayWeb");
		data.mShowUI = element->IntAttribute("ShowUI");
		data.mDesc = element->Attribute("Desc");
		data.mName = element->Attribute("Name");
		data.mVersionName = element->Attribute("VersionName");
		data.mVersionCode = element->IntAttribute("VersionCode");
		data.mPath = element->Attribute("Path");
		data.mPlatform = element->Attribute("Platform");
		data.mPackageName = element->Attribute("PackageName");
		data.mLogo = element->Attribute("Logo");
		data.mEnableSplash = element->BoolAttribute("EnableSplash");
		data.mEnableRealName = element->BoolAttribute("EnableRealName");
		data.mInfo = element->Attribute("Info");
		data.mChargingCharge = element->IntAttribute("ChargingCharge");
		data.mCompany = element->Attribute("Company");
		data.mExchangeLimit = element->IntAttribute("ExchangeLimit");
		data.mRankShow = element->IntAttribute("RankShow");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ChannelCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ChannelCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ChannelCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ChannelCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ChannelCFGData data;
		LuaCfgHelper::readString(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "IsPayWeb", data.mIsPayWeb);
		LuaCfgHelper::readInt(L, "ShowUI", data.mShowUI);
		LuaCfgHelper::readString(L, "Desc", data.mDesc);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readString(L, "VersionName", data.mVersionName);
		LuaCfgHelper::readInt(L, "VersionCode", data.mVersionCode);
		LuaCfgHelper::readString(L, "Path", data.mPath);
		LuaCfgHelper::readString(L, "Platform", data.mPlatform);
		LuaCfgHelper::readString(L, "PackageName", data.mPackageName);
		LuaCfgHelper::readString(L, "Logo", data.mLogo);
		LuaCfgHelper::readBool(L, "EnableSplash", data.mEnableSplash);
		LuaCfgHelper::readBool(L, "EnableRealName", data.mEnableRealName);
		LuaCfgHelper::readString(L, "Info", data.mInfo);
		LuaCfgHelper::readInt(L, "ChargingCharge", data.mChargingCharge);
		LuaCfgHelper::readString(L, "Company", data.mCompany);
		LuaCfgHelper::readInt(L, "ExchangeLimit", data.mExchangeLimit);
		LuaCfgHelper::readInt(L, "RankShow", data.mRankShow);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ChannelCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ChannelCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ChannelCFG* M_ChannelCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ChannelCFG());
	}
	return msSingleton.get();
}

void M_ChannelCFG::Release()
{
	msSingleton.reset(nullptr);
}
